/* ************************************************************************** */
/*                                                                            */
/*                                                        :::      ::::::::   */
/*   ft_select.h                                        :+:      :+:    :+:   */
/*                                                    +:+ +:+         +:+     */
/*   By: ale-batt <ale-batt@student.42.fr>          +#+  +:+       +#+        */
/*                                                +#+#+#+#+#+   +#+           */
/*   Created: 2015/12/10 00:00:29 by ale-batt          #+#    #+#             */
/*   Updated: 2016/01/25 19:00:33 by ale-batt         ###   ########.fr       */
/*                                                                            */
/* ************************************************************************** */

#ifndef FT_SELECT_H
# define FT_SELECT_H

# include "libft.h"
# include <termios.h>
# include <term.h>
# include <curses.h>
# include <termcap.h>
# include <sys/ioctl.h>

# define CONTENT ((t_argv *)(tmp->content))
# define CONTENT_NEXT ((t_argv *)(tmp->next->content))
# define CONTENT_PREV ((t_argv *)(tmp->prev->content))

# define FTKEY_ARROW  key[0] == 27 && key[1] == 91
# define FTKEY_UP     FTKEY_ARROW && key[2] == 65
# define FTKEY_DOWN   FTKEY_ARROW && key[2] == 66
# define FTKEY_RIGHT  FTKEY_ARROW && key[2] == 67
# define FTKEY_LEFT   FTKEY_ARROW && key[2] == 68
# define FTKEY_ECHAP  key[0] == 27&& key[2] == 0  && key[3] == 0
# define FTKEY_SPACE  key[0] == 32&& key[2] == 0  && key[3] == 0
# define FTKEY_ENTER  key[0] == 10&& key[2] == 0  && key[3] == 0
# define FTKEY_DEL    key[0] == 127&& key[2] == 0  && key[3] == 0

# define AFFCNT 0

struct termios		g_term_save;

typedef struct		s_term
{
	char			*name;
	int				save_am;
	int				width;
	int				height;
}					t_term;

typedef struct		s_env
{
	t_llist			*list;
	int				fd_tty;
	char			*list_ret;
	struct termios	term;
}					t_env;

typedef	struct		s_argv
{
	char			*word;
	int				len;
	int				cursor;
	int				select;
}					t_argv;

typedef	struct	s_printargv
{
	int				y;
	int				bigger_word;
	int				y_win;
	int				x_win;
	int				mov_size;
}					t_printav;


int					ft_select(void);
void				print_list(void);

t_llist				*parser_argv(char **argv);

t_env				*g_env(t_env *env);


int					handle_key(char *key);
void				move_cursor(t_llist *tmp, char *key);
t_llist				*get_current(void);


/*
 * tools.c
*/
int					ft_iputchar(int c);
char				*ft_tgetstr(char *id);
int					ft_is_dir(const char *path);

/*
 * signals.c
*/
void				signal_handler(int sig);
void				ft_signal_on(void);
void				ft_signal_off(void);

/*
 * terminal.c
*/
int					ft_terminal_on(void);
int					ft_terminal_off(struct termios *term);

/*
 * tcp_function.c
*/
void				move_cursor_to(int x, int y);
int					*ft_winsize(void);
void				ft_clear_screen(void);

void				underline_line(t_llist *tmp, int fd, int size);
void				ft_reverse_video(t_llist *tmp, int fd, int size);

#endif
