/* ************************************************************************** */
/*                                                                            */
/*                                                        :::      ::::::::   */
/*   ft_strsplit.c                                      :+:      :+:    :+:   */
/*                                                    +:+ +:+         +:+     */
/*   By: ale-batt <ale-batt@student.42.fr>          +#+  +:+       +#+        */
/*                                                +#+#+#+#+#+   +#+           */
/*   Created: 2014/11/07 16:00:30 by ale-batt          #+#    #+#             */
/*   Updated: 2015/03/10 11:28:16 by ale-batt         ###   ########.fr       */
/*                                                                            */
/* ************************************************************************** */

#include "libft.h"

static int	ft_nb_chaine_in_tab(const char *str, char c)
{
	int	i;
	int	nb_tab;

	i = 0;
	nb_tab = 0;
	while (str[i])
	{
		if (str[i] != c)
		{
			while (str[i] && str[i] != c)
				i++;
			nb_tab++;
		}
		else
			i++;
	}
	return (nb_tab);
}

static	int	ft_nb_car_in_chaine(const char *str, char c, int i)
{
	int	nb_car;

	nb_car = 0;
	while (str[i] && str[i] != c)
	{
		i++;
		nb_car++;
	}
	return (nb_car);
}

char		**ft_strsplit(const char *s, char c)
{
	int		nb_chaine;
	char	**tab;
	int		i_s;
	int		x;
	int		y;

	if (!s)
		return (NULL);
	i_s = 0;
	y = 0;
	nb_chaine = ft_nb_chaine_in_tab(s, c);
	if ((tab = (char **)malloc((nb_chaine + 1) * sizeof(char *))) == NULL)
		return (NULL);
	tab[nb_chaine] = 0;
	while (y < nb_chaine)
	{
		while (s[i_s] == c)
			i_s++;
		tab[y] = (char *)malloc((ft_nb_car_in_chaine(s, c, i_s) + 1));
		x = 0;
		while (s[i_s] && s[i_s] != c)
			tab[y][x++] = s[i_s++];
		tab[y++][x] = '\0';
	}
	return (tab);
}
