/* ************************************************************************** */
/*                                                                            */
/*                                                        :::      ::::::::   */
/*   get_next_line.c                                    :+:      :+:    :+:   */
/*                                                    +:+ +:+         +:+     */
/*   By: ale-batt <marvin@42.fr>                    +#+  +:+       +#+        */
/*                                                +#+#+#+#+#+   +#+           */
/*   Created: 2015/01/19 14:51:16 by ale-batt          #+#    #+#             */
/*   Updated: 2015/03/19 16:35:59 by ale-batt         ###   ########.fr       */
/*                                                                            */
/* ************************************************************************** */

#include "get_next_line.h"

static char		*ft_read_buff(t_gnl *data, int fd)
{
	char	*buff;
	char	*tmp;

	data->ret = 1;
	buff = (char *)malloc(sizeof(char) * BUFF_SIZE + 1);
	tmp = (char *)malloc(sizeof(char) * (BUFF_SIZE + 1));
	while (data->ret != 0)
	{
		if ((data->ret = read(fd, buff, BUFF_SIZE)) == -1)
			return (NULL);
		buff[data->ret] = '\0';
		if (ft_strchr(buff, '\n') == NULL)
		{
			if (tmp == NULL)
				tmp = ft_strfdup(buff);
			else
				tmp = ft_strfjoin(tmp, buff);
		}
		else
		{
			tmp = (tmp == NULL) ? ft_strfdup(buff) : ft_strfjoin(tmp, buff);
			return (tmp);
		}
	}
	return (tmp);
}

static char		*ft_struntil(char *tmp)
{
	size_t	i;
	size_t	j;
	char	*str;

	i = 0;
	j = 0;
	str = (char *)malloc((sizeof(char) * ft_strlen(tmp)) + 1);
	while (tmp[i] && tmp[i] != '\n')
		str[j++] = tmp[i++];
	str[j] = '\0';
	return (str);
}

static char		*get_my_buff(t_gnl *data, int fd)
{
	char *buff;

	buff = NULL;
	if (ft_strchr(data->suite, '\n') == NULL)
	{
		if (data->suite != NULL)
		{
			if (ft_strlen(data->suite) == 0)
				buff = ft_read_buff(data, fd);
			else
				buff = ft_strfjoin(data->suite, ft_read_buff(data, fd));
		}
		else
			buff = ft_strfjoin(buff, ft_read_buff(data, fd));
	}
	else
		buff = ft_strdup(data->suite);
	return (buff);
}

static	int		gnl_retour(t_gnl *data)
{
	if (data->ret == 0 || data->suite == NULL)
	{
		if (data)
		{
			free(data->suite);
			free(data);
		}
		return (0);
	}
	else
		return (1);
}

int				get_next_line(int const fd, char **line)
{
	static t_gnl	*data;
	static int		nb = 0;
	char			*buff;

	if (line == NULL)
		return (-1);
	if (nb == 0)
	{
		if (!(data = (t_gnl *)malloc(sizeof(t_gnl))))
			return (-1);
		data->suite = (char *)malloc(sizeof(char) * BUFF_SIZE + 1);
		nb = 1;
	}
	if (!(buff = get_my_buff(data, fd)))
		return (-1);
	*line = ft_struntil(buff);
	free(data->suite);
	data->suite = ft_strdup(1 + ft_strchr(buff, '\n'));
	free(buff);
	nb = gnl_retour(data);
	return (nb);
}
