/* ************************************************************************** */
/*                                                                            */
/*                                                        :::      ::::::::   */
/*   key_handler.c                                      :+:      :+:    :+:   */
/*                                                    +:+ +:+         +:+     */
/*   By: ale-batt <ale-batt@student.42.fr>          +#+  +:+       +#+        */
/*                                                +#+#+#+#+#+   +#+           */
/*   Created: 2016/01/24 16:49:32 by ale-batt          #+#    #+#             */
/*   Updated: 2016/01/25 20:06:31 by ale-batt         ###   ########.fr       */
/*                                                                            */
/* ************************************************************************** */

#include "ft_select.h"

static void		select_elem(t_llist *tmp)
{
	char down[4];

	down[0] = 27;
	down[1] = 91;
	down[2] = 66;
	down[3] = 0;
	CONTENT->select = (CONTENT->select == 0) ? 1 : 0;
	move_cursor(tmp, down);
}

static int		delete_elem(t_env *e, t_llist *tmp)
{
	t_llist	*prev;
	t_llist	*next;
	char	mov[4];

	mov[0] = 27;
	mov[1] = 91;
	mov[2] = (tmp->prev == NULL) ? 66 : 65;
	mov[3] = 0;
	prev = tmp->prev;
	next = tmp->next;
	if (tmp->prev == NULL && tmp->next == NULL)
		return (0);
	move_cursor(tmp, mov);
	free(CONTENT->word);
	free(CONTENT);
	free(tmp);
	if (prev)
		prev->next = (next) ? next : NULL;
	else
		e->list = next;
	if (next)
		next->prev = (prev) ? prev : NULL;
	else
		next = NULL;
	return (1);
}

static int		send_select_elem(t_env *e)
{
	t_llist	*tmp;

	tmp = e->list;
	while (tmp)
	{
		if (CONTENT->select == 1)
		{
			if (e->list_ret == NULL)
				e->list_ret = ft_strdup(CONTENT->word);
			else
				e->list_ret = ft_ultijoin(e->list_ret, " ", CONTENT->word, 0);
		}
		tmp = tmp->next;
	}
	return (0);
}

int				handle_key(char *key)
{
	t_llist	*tmp;
	t_env	*e;

	e = g_env(NULL);
	tmp = get_current();
	if (FTKEY_ECHAP)
		return (-1);
	else if (FTKEY_ARROW)
		move_cursor(tmp, key);
	else if (FTKEY_SPACE)
		select_elem(tmp);
	else if (FTKEY_DEL)
		return (delete_elem(e, tmp));
	else if (FTKEY_ENTER)
		return (send_select_elem(e));
	return (1);
}
